=== docs/docbook/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Burkhard Lück <lueck@hube-lueck.de>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
########### install files ###############
#
#
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR gcompris)
