=== src/activities/bargame_2players/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2017 UTKARSH TIWARI <iamutkarshtiwari@kde.org>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/bargame_2players
  QML_FILES
  *.qml
  RESOURCES
  *.svg
  DEPENDENCIES
  bargame
)
