=== src/activities/binary_bulb/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2018 Rajat Asthana <rajatasthana4@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/binary_bulb
  QML_FILES
  *.qml
  *.js
  resource/*.qml
  resource/*/Data.qml
  RESOURCES
  *.svg
  resource/*.svg
)
