=== src/activities/drawing_wheels/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2025 Bruno Anselme <be.root@free.fr>
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/drawing_wheels
  QML_FILES
  *.qml
  *.js
  RESOURCES
  *.svg
  resource/*
)
