=== debian/changelog ===
gcompris-qt (26.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Update the patches:
    - disable-openssl.diff: drop, now OpenSSL is actually used
  * Update the build dependencies according to the upstream build system:
    - add libssl-dev, qt6-graphs-dev, and qt6-quick3d-dev
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Wed, 04 Feb 2026 08:07:17 +0100
